/*
 * Copyright (c) 2000 Blue Mug, Inc.  All Rights Reserved.
 */

#ifndef _HERMIT_TARGET_FLASH_H_
#define _HERMIT_TARGET_FLASH_H_

#if defined(SUZAKU)
#include <target/htypes.h>
#include <byteorder/big_endian.h>
#endif

//Device-ID,Manufacturer-ID
#define FLASH_DID_UNKNOWN              (0x00000000)
#define FLASH_DID_AMD_AM29LV160DB      (0x22490001)
#define FLASH_DID_FUJITSU_MBM29LV160BE (0x22490004)
#define FLASH_DID_ST_M29W160EB         (0x22490020)
#define FLASH_DID_ST_M29DW323DB        (0x225f0020)

#if defined(ARMADILLOJ_CTYPE)
#define PROTECT_START (0x02000000)
#define PROTECT_END   (0x02010000 - 1)
#else
#define PROTECT_START 1
#define PROTECT_END   0
#endif


#if defined(ARMADILLOJ_STYPE) || defined(ARMADILLOJ_CTYPE) || defined(SUZAKU)
#define FLASH_BASE_MASK (0xFF000000)
#else
#define FLASH_BASE_MASK (0xF0000000)
#endif

#define FLASH_8MiB (0x17)

#include <target/command.h>

extern const command_t flash_program_command;
extern const command_t flash_erase_command;

int flash_program(const unsigned long from,
		  const unsigned long to,
		  const unsigned int size);
int flash_erase(const unsigned long erase_addr);
unsigned long flash_get_id(const unsigned long base_addr);
int flash_get_size(const unsigned long base_addr);

#endif /* _HERMIT_TARGET_FLASH_H_ */
